package io.fabric8.openshift.api.model;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link SecretBuildSource} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractSecretBuildSourceAssert<S extends AbstractSecretBuildSourceAssert<S, A>, A extends SecretBuildSource> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractSecretBuildSourceAssert}</code> to make assertions on actual SecretBuildSource.
   * @param actual the SecretBuildSource we want to make assertions on.
   */
  protected AbstractSecretBuildSourceAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual SecretBuildSource we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property destinationDir so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert destinationDir()  {
    // check that actual SecretBuildSource we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getDestinationDir()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "destinationDir"));
  }


  /**
   * Navigates to the property secret so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.LocalObjectReferenceAssert secret()  {
    // check that actual SecretBuildSource we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.LocalObjectReferenceAssert) assertThat(actual.getSecret()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "secret"));
  }


}
